/*
 * Importacao1de4.java
 */
package br.com.unimed.importador.visao;

import br.com.unimed.importador.cadastro.mascara_de_arquivo.controlador.MascaraDeArquivoJpaController;
import br.com.unimed.importador.dominio.ControladorDeImportacao;
import br.com.unimed.importador.cadastro.mascara_de_arquivo.persistencia.MascaraDeArquivo;
import br.com.unimed.importador.cadastro.mascara_de_arquivo.visao.FrmMascaraManutencaoDeArquivo;
import br.com.unimed.importador.cadastro.mascara_de_arquivo.visao.FrmMascaraManutencaoDeRegistro;
import org.jdesktop.application.Action;
import org.jdesktop.application.ResourceMap;
import org.jdesktop.application.SingleFrameApplication;
import org.jdesktop.application.FrameView;
import org.jdesktop.application.TaskMonitor;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.net.URL;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import javax.help.HelpBroker;
import javax.help.HelpSet;
import javax.swing.Timer;
import javax.swing.Icon;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JOptionPane;

/**
 * The application's main frame.
 */
public class Importacao1de4 extends FrameView {

    private SingleFrameApplication app;
    private ControladorDeImportacao controlador;
    private static FrameView _instance = null;
    private static String tipoArquivoOrigem = "";
    private static String ArquivoOrigem = "";
    private boolean updateComboVersion = false;
   

    public static FrameView getInstance(SingleFrameApplication app) {
        if (_instance == null) {
            _instance = new Importacao1de4(app);
        }

        return _instance;
    }

    private Importacao1de4(SingleFrameApplication app) {
        super(app);
        this.app = app;
        initComponents();

        /* desaloca a GUI e libera recursos quando sair */
        getFrame().setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

        Main.getApplication().getMainFrame().setTitle("Importador");

        atualizaComboVersao();
        loadParameters();

        // status bar initialization - message timeout, idle icon and busy animation, etc
        ResourceMap resourceMap = getResourceMap();
        int messageTimeout = resourceMap.getInteger("StatusBar.messageTimeout");
        messageTimer = new Timer(messageTimeout, new ActionListener() {

            public void actionPerformed(ActionEvent e) {
            }
        });
        messageTimer.setRepeats(false);
        int busyAnimationRate = resourceMap.getInteger("StatusBar.busyAnimationRate");
        for (int i = 0; i < busyIcons.length; i++) {
            busyIcons[i] = resourceMap.getIcon("StatusBar.busyIcons[" + i + "]");
        }
        busyIconTimer = new Timer(busyAnimationRate, new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                busyIconIndex = (busyIconIndex + 1) % busyIcons.length;
            }
        });
        idleIcon = resourceMap.getIcon("StatusBar.idleIcon");


        // connecting action tasks to status bar via TaskMonitor
        TaskMonitor taskMonitor = new TaskMonitor(getApplication().getContext());
        taskMonitor.addPropertyChangeListener(new java.beans.PropertyChangeListener() {

            public void propertyChange(java.beans.PropertyChangeEvent evt) {
                String propertyName = evt.getPropertyName();
                if ("started".equals(propertyName)) {
                    if (!busyIconTimer.isRunning()) {
                        busyIconIndex = 0;
                        busyIconTimer.start();
                    }

                } else if ("done".equals(propertyName)) {
                    busyIconTimer.stop();

                } else if ("message".equals(propertyName)) {
                    String text = (String) (evt.getNewValue());
                    messageTimer.restart();
                } else if ("progress".equals(propertyName)) {
                    int value = (Integer) (evt.getNewValue());

                }
            }
        });





    }

    @Action
    public void showAboutBox() {
        if (aboutBox == null) {
            JFrame mainFrame = Main.getApplication().getMainFrame();
            aboutBox = new AboutBox(mainFrame);
            aboutBox.setLocationRelativeTo(mainFrame);
        }
        Main.getApplication().show(aboutBox);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        mainPanel = new javax.swing.JPanel();
        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jTxtSelecionarArquivoOrigem = new javax.swing.JTextField();
        jCmbTipoArquivoOrigem = new javax.swing.JComboBox();
        jLabel13 = new javax.swing.JLabel();
        jButton2 = new javax.swing.JButton();
        jLabel3 = new javax.swing.JLabel();
        jLabel18 = new javax.swing.JLabel();
        jComboBoxNumVersao = new javax.swing.JComboBox();
        jPanel4 = new javax.swing.JPanel();
        jButton1 = new javax.swing.JButton();
        jButton3 = new javax.swing.JButton();
        jButton4 = new javax.swing.JButton();
        jButton5 = new javax.swing.JButton();
        jButton6 = new javax.swing.JButton();
        jPanel5 = new javax.swing.JPanel();
        jLabel12 = new javax.swing.JLabel();
        jLabel19 = new javax.swing.JLabel();
        jLabel20 = new javax.swing.JLabel();
        jLabel21 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        menuBar = new javax.swing.JMenuBar();
        javax.swing.JMenu fileMenu = new javax.swing.JMenu();
        javax.swing.JMenuItem exitMenuItem = new javax.swing.JMenuItem();
        jMenuCadastro = new javax.swing.JMenu();
        jMenuItemMascaraDeArquivo = new javax.swing.JMenuItem();
        jMenuMascaraDeRegistro = new javax.swing.JMenuItem();
        javax.swing.JMenu helpMenu = new javax.swing.JMenu();
        javax.swing.JMenuItem aboutMenuItem = new javax.swing.JMenuItem();
        jPanel3 = new javax.swing.JPanel();

        mainPanel.setName("mainPanel"); // NOI18N
        mainPanel.setPreferredSize(new java.awt.Dimension(920, 416));
        mainPanel.setLayout(null);

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder("Origem"));
        jPanel1.setName("jPanel1"); // NOI18N
        jPanel1.setLayout(null);

        jLabel1.setName("jLabel1"); // NOI18N
        jPanel1.add(jLabel1);
        jLabel1.setBounds(56, 33, 0, 0);

        jLabel2.setName("jLabel2"); // NOI18N
        jPanel1.add(jLabel2);
        jLabel2.setBounds(56, 79, 0, 0);

        jTxtSelecionarArquivoOrigem.setName("jTxtSelecionarArquivoOrigem"); // NOI18N
        jPanel1.add(jTxtSelecionarArquivoOrigem);
        jTxtSelecionarArquivoOrigem.setBounds(140, 180, 320, 28);

        jCmbTipoArquivoOrigem.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "CARGAMENSAL" }));
        jCmbTipoArquivoOrigem.setName("jCmbTipoArquivoOrigem"); // NOI18N
        jCmbTipoArquivoOrigem.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                jCmbTipoArquivoOrigemItemStateChanged(evt);
            }
        });
        jCmbTipoArquivoOrigem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCmbTipoArquivoOrigemActionPerformed(evt);
            }
        });
        jPanel1.add(jCmbTipoArquivoOrigem);
        jCmbTipoArquivoOrigem.setBounds(140, 120, 150, 28);

        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(br.com.unimed.importador.visao.Main.class).getContext().getResourceMap(Importacao1de4.class);
        jLabel13.setText(resourceMap.getString("jLabel13.text")); // NOI18N
        jLabel13.setName("jLabel13"); // NOI18N
        jPanel1.add(jLabel13);
        jLabel13.setBounds(70, 180, 56, 18);

        jButton2.setIcon(resourceMap.getIcon("jButton2.icon")); // NOI18N
        jButton2.setText(resourceMap.getString("jButton2.text")); // NOI18N
        jButton2.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
        jButton2.setName("jButton2"); // NOI18N
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });
        jPanel1.add(jButton2);
        jButton2.setBounds(465, 180, 120, 27);

        jLabel3.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel3.setText(resourceMap.getString("jLabel3.text")); // NOI18N
        jLabel3.setName("jLabel3"); // NOI18N
        jPanel1.add(jLabel3);
        jLabel3.setBounds(52, 70, 80, 18);

        jLabel18.setText(resourceMap.getString("jLabel18.text")); // NOI18N
        jLabel18.setName("jLabel18"); // NOI18N
        jPanel1.add(jLabel18);
        jLabel18.setBounds(20, 120, 112, 18);

        jComboBoxNumVersao.setName("jComboBoxNumVersao"); // NOI18N
        jComboBoxNumVersao.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBoxNumVersaoActionPerformed(evt);
            }
        });
        jPanel1.add(jComboBoxNumVersao);
        jComboBoxNumVersao.setBounds(140, 70, 150, 28);

        mainPanel.add(jPanel1);
        jPanel1.setBounds(330, 50, 590, 290);

        jPanel4.setBorder(null);
        jPanel4.setName("jPanel4"); // NOI18N

        jButton1.setIcon(resourceMap.getIcon("jButton1.icon")); // NOI18N
        jButton1.setText(resourceMap.getString("jButton1.text")); // NOI18N
        jButton1.setEnabled(false);
        jButton1.setName("jButton1"); // NOI18N

        jButton3.setIcon(resourceMap.getIcon("jButton3.icon")); // NOI18N
        jButton3.setText(resourceMap.getString("jButton3.text")); // NOI18N
        jButton3.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
        jButton3.setName("jButton3"); // NOI18N
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });

        jButton4.setIcon(resourceMap.getIcon("jButton4.icon")); // NOI18N
        jButton4.setText(resourceMap.getString("jButton4.text")); // NOI18N
        jButton4.setEnabled(false);
        jButton4.setFocusPainted(false);
        jButton4.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
        jButton4.setName("jButton4"); // NOI18N

        jButton5.setIcon(resourceMap.getIcon("jButton5.icon")); // NOI18N
        jButton5.setText(resourceMap.getString("jButton5.text")); // NOI18N
        jButton5.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
        jButton5.setName("jButton5"); // NOI18N
        jButton5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton5ActionPerformed(evt);
            }
        });

        jButton6.setIcon(resourceMap.getIcon("jButton6.icon")); // NOI18N
        jButton6.setText(resourceMap.getString("jButton6.text")); // NOI18N
        jButton6.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
        jButton6.setName("jButton6"); // NOI18N
        jButton6.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton6ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel4Layout = new javax.swing.GroupLayout(jPanel4);
        jPanel4.setLayout(jPanel4Layout);
        jPanel4Layout.setHorizontalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jButton1, javax.swing.GroupLayout.PREFERRED_SIZE, 99, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButton3, javax.swing.GroupLayout.PREFERRED_SIZE, 99, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 16, Short.MAX_VALUE)
                .addComponent(jButton4, javax.swing.GroupLayout.PREFERRED_SIZE, 104, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(jButton5, javax.swing.GroupLayout.PREFERRED_SIZE, 99, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(jButton6, javax.swing.GroupLayout.PREFERRED_SIZE, 115, javax.swing.GroupLayout.PREFERRED_SIZE))
        );
        jPanel4Layout.setVerticalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE, false)
                .addComponent(jButton6, javax.swing.GroupLayout.PREFERRED_SIZE, 41, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addComponent(jButton5, javax.swing.GroupLayout.PREFERRED_SIZE, 34, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addComponent(jButton4, javax.swing.GroupLayout.PREFERRED_SIZE, 27, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addComponent(jButton3, javax.swing.GroupLayout.PREFERRED_SIZE, 27, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addComponent(jButton1, javax.swing.GroupLayout.PREFERRED_SIZE, 27, javax.swing.GroupLayout.PREFERRED_SIZE))
        );

        jPanel4Layout.linkSize(javax.swing.SwingConstants.VERTICAL, new java.awt.Component[] {jButton1, jButton3, jButton4, jButton5, jButton6});

        mainPanel.add(jPanel4);
        jPanel4.setBounds(320, 357, 586, 50);

        jPanel5.setBackground(resourceMap.getColor("jPanel5.background")); // NOI18N
        jPanel5.setName("jPanel5"); // NOI18N

        jLabel12.setFont(resourceMap.getFont("jLabel12.font")); // NOI18N
        jLabel12.setText(resourceMap.getString("jLabel12.text")); // NOI18N
        jLabel12.setName("jLabel12"); // NOI18N

        jLabel19.setText(resourceMap.getString("jLabel19.text")); // NOI18N
        jLabel19.setName("jLabel19"); // NOI18N

        jLabel20.setText(resourceMap.getString("jLabel20.text")); // NOI18N
        jLabel20.setName("jLabel20"); // NOI18N

        jLabel21.setText(resourceMap.getString("jLabel21.text")); // NOI18N
        jLabel21.setName("jLabel21"); // NOI18N

        jLabel4.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel4.setIcon(new javax.swing.ImageIcon(getClass().getResource("/br/com/unimed/importador/visao/resources/unimed.png"))); // NOI18N
        jLabel4.setText(resourceMap.getString("jLabel4.text")); // NOI18N
        jLabel4.setName("jLabel4"); // NOI18N

        javax.swing.GroupLayout jPanel5Layout = new javax.swing.GroupLayout(jPanel5);
        jPanel5.setLayout(jPanel5Layout);
        jPanel5Layout.setHorizontalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel5Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel12)
                    .addComponent(jLabel19)
                    .addComponent(jLabel20)
                    .addComponent(jLabel21)
                    .addComponent(jLabel4, javax.swing.GroupLayout.DEFAULT_SIZE, 286, Short.MAX_VALUE))
                .addContainerGap())
        );
        jPanel5Layout.setVerticalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel5Layout.createSequentialGroup()
                .addGap(44, 44, 44)
                .addComponent(jLabel12)
                .addGap(6, 6, 6)
                .addComponent(jLabel19)
                .addGap(6, 6, 6)
                .addComponent(jLabel20)
                .addGap(6, 6, 6)
                .addComponent(jLabel21)
                .addGap(91, 91, 91)
                .addComponent(jLabel4, javax.swing.GroupLayout.PREFERRED_SIZE, 84, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(114, Short.MAX_VALUE))
        );

        mainPanel.add(jPanel5);
        jPanel5.setBounds(0, 0, 310, 420);

        menuBar.setName("menuBar"); // NOI18N

        fileMenu.setText(resourceMap.getString("fileMenu.text")); // NOI18N
        fileMenu.setName("fileMenu"); // NOI18N

        javax.swing.ActionMap actionMap = org.jdesktop.application.Application.getInstance(br.com.unimed.importador.visao.Main.class).getContext().getActionMap(Importacao1de4.class, this);
        exitMenuItem.setAction(actionMap.get("quit")); // NOI18N
        exitMenuItem.setIcon(resourceMap.getIcon("exitMenuItem.icon")); // NOI18N
        exitMenuItem.setName("exitMenuItem"); // NOI18N
        fileMenu.add(exitMenuItem);

        menuBar.add(fileMenu);

        jMenuCadastro.setText(resourceMap.getString("jMenuCadastro.text")); // NOI18N
        jMenuCadastro.setName("jMenuCadastro"); // NOI18N

        jMenuItemMascaraDeArquivo.setText(resourceMap.getString("jMenuItemMascaraDeArquivo.text")); // NOI18N
        jMenuItemMascaraDeArquivo.setName("jMenuItemMascaraDeArquivo"); // NOI18N
        jMenuItemMascaraDeArquivo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItemMascaraDeArquivoActionPerformed(evt);
            }
        });
        jMenuCadastro.add(jMenuItemMascaraDeArquivo);

        jMenuMascaraDeRegistro.setText(resourceMap.getString("jMenuMascaraDeRegistro.text")); // NOI18N
        jMenuMascaraDeRegistro.setName("jMenuMascaraDeRegistro"); // NOI18N
        jMenuMascaraDeRegistro.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuMascaraDeRegistroActionPerformed(evt);
            }
        });
        jMenuCadastro.add(jMenuMascaraDeRegistro);

        menuBar.add(jMenuCadastro);

        helpMenu.setText(resourceMap.getString("helpMenu.text")); // NOI18N

        aboutMenuItem.setAction(actionMap.get("showAboutBox")); // NOI18N
        aboutMenuItem.setIcon(resourceMap.getIcon("aboutMenuItem.icon")); // NOI18N
        aboutMenuItem.setName("aboutMenuItem"); // NOI18N
        helpMenu.add(aboutMenuItem);

        menuBar.add(helpMenu);

        jPanel3.setName("jPanel3"); // NOI18N

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 100, Short.MAX_VALUE)
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 100, Short.MAX_VALUE)
        );

        setComponent(mainPanel);
        setMenuBar(menuBar);
    }// </editor-fold>//GEN-END:initComponents

    private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
        // TODO add your handling code here:

        ArquivoOrigem = jTxtSelecionarArquivoOrigem.getText();
        tipoArquivoOrigem = (String) jCmbTipoArquivoOrigem.getSelectedItem();

        File f = new File(ArquivoOrigem);

        if (ArquivoOrigem.length() == 0 || !f.isFile()) {
            JOptionPane.showMessageDialog(null, "Informe o arquivo", "Erro no arquivo",
                    JOptionPane.ERROR_MESSAGE);

            return;
        }


        //controlador.setupAdicionarMascaraRegistro(tipoArquivoOrigem);

        Main.getApplication().show(Importacao2de4.getInstance(app));
        Main.getApplication().hide(Importacao1de4.getInstance(app));


    }//GEN-LAST:event_jButton3ActionPerformed

  

    private void jButton5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton5ActionPerformed
        // TODO add your handling code here:
        System.exit(0);
    }//GEN-LAST:event_jButton5ActionPerformed

    private void jCmbTipoArquivoOrigemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCmbTipoArquivoOrigemActionPerformed
    }//GEN-LAST:event_jCmbTipoArquivoOrigemActionPerformed

    private void jCmbTipoArquivoOrigemItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jCmbTipoArquivoOrigemItemStateChanged
    }//GEN-LAST:event_jCmbTipoArquivoOrigemItemStateChanged

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        // TODO add your handling code here:
        JFileChooser fileChooser = new JFileChooser();
        fileChooser.setFileSelectionMode(JFileChooser.FILES_ONLY);

        int result = fileChooser.showOpenDialog(null);

        if (result == JFileChooser.CANCEL_OPTION) {
            return;
        }

        File fileName = fileChooser.getSelectedFile();

        if (fileName == null || fileName.getName().length() == 0) {
            JOptionPane.showMessageDialog(null, "Nome de Arquivo inválido", "Erro",
                    JOptionPane.ERROR_MESSAGE);

        } else {

            jTxtSelecionarArquivoOrigem.setText(fileName.getAbsolutePath());
        }

    }//GEN-LAST:event_jButton2ActionPerformed

    private void jButton6ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton6ActionPerformed
        // TODO add your handling code here:
        ImportacaoHelp.getInstance().openHelp();
    }//GEN-LAST:event_jButton6ActionPerformed

    private void jMenuItemMascaraDeArquivoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItemMascaraDeArquivoActionPerformed
        // TODO add your handling code here:
        FrmMascaraManutencaoDeArquivo manutencaoDeArquivo =
                new FrmMascaraManutencaoDeArquivo();

        manutencaoDeArquivo.setVisible(true);
    }//GEN-LAST:event_jMenuItemMascaraDeArquivoActionPerformed

    private void jMenuMascaraDeRegistroActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuMascaraDeRegistroActionPerformed
        // TODO add your handling code here:
        FrmMascaraManutencaoDeRegistro manutencaoDeRegistro =
                new FrmMascaraManutencaoDeRegistro();
    }//GEN-LAST:event_jMenuMascaraDeRegistroActionPerformed

    private void jComboBoxNumVersaoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBoxNumVersaoActionPerformed
        // TODO add your handling code here:
        if(!updateComboVersion){
            loadParameters();
        }
    }//GEN-LAST:event_jComboBoxNumVersaoActionPerformed

     static String getTipoArquivoOrigem() {
        return tipoArquivoOrigem;
    }

     static String getArquivoOrigem() {
        return ArquivoOrigem;
    }

     static String getVersao() {
        return (String) jComboBoxNumVersao.getSelectedItem();
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JButton jButton4;
    private javax.swing.JButton jButton5;
    private javax.swing.JButton jButton6;
    private javax.swing.JComboBox jCmbTipoArquivoOrigem;
    private static javax.swing.JComboBox jComboBoxNumVersao;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel18;
    private javax.swing.JLabel jLabel19;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel20;
    private javax.swing.JLabel jLabel21;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JMenu jMenuCadastro;
    private javax.swing.JMenuItem jMenuItemMascaraDeArquivo;
    private javax.swing.JMenuItem jMenuMascaraDeRegistro;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JTextField jTxtSelecionarArquivoOrigem;
    private javax.swing.JPanel mainPanel;
    private javax.swing.JMenuBar menuBar;
    // End of variables declaration//GEN-END:variables
    private final Timer messageTimer;
    private final Timer busyIconTimer;
    private final Icon[] busyIcons = new Icon[15];
    private int busyIconIndex = 0;
    private JDialog aboutBox;
    private final Icon idleIcon;

    private void atualizaComboVersao() {
        MascaraDeArquivoJpaController mascaraController =
                new MascaraDeArquivoJpaController();

        updateComboVersion = true;

        List<MascaraDeArquivo> list = mascaraController.findMascaraDeArquivoEntities();
        Iterator<MascaraDeArquivo> iteratorMascara = list.iterator();
        List noDup = new ArrayList();


        /* preenche lista com todas as versões */
        while (iteratorMascara.hasNext()) {
            MascaraDeArquivo temp = iteratorMascara.next();
            noDup.add(temp.getMascaraDeArquivoPK().getNumVersaoMascaraDeArquivo());
        }


        /* retira as duplicatas */

        HashSet set = new HashSet(noDup);
        Iterator itComboVersao = set.iterator();

        List ordenar = new ArrayList();

        while (itComboVersao.hasNext()) {
            ordenar.add((Short) itComboVersao.next());
        }

        /* ordena as versoes */
        Collections.sort(ordenar);
        itComboVersao = ordenar.iterator();

        jComboBoxNumVersao.removeAllItems();

        while (itComboVersao.hasNext()) {
            String t = Short.toString((Short) itComboVersao.next());
            jComboBoxNumVersao.addItem(t);
        }

        updateComboVersion = false;

        jComboBoxNumVersao.setSelectedIndex(jComboBoxNumVersao.getItemCount() - 1);


    }

    private void loadParameters() {
        /* inicia o combo numero de versoes */
     

        /* preenche combo com o tipo de arquivo */
        controlador = ControladorDeImportacao.getInstance();
        List<String> tiposDeArquivos = new ArrayList<String>();
        tiposDeArquivos = controlador.obterTiposDeArquivo(
                Integer.parseInt(((String) jComboBoxNumVersao.getSelectedItem())));



        jCmbTipoArquivoOrigem.removeAllItems();
        for (String e : tiposDeArquivos) {
            jCmbTipoArquivoOrigem.addItem(e);
        }

    }
}
